<!doctype HTML>
<html  lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8" />
<title>Create 3D Games: Downloads</title>   
<meta name="description" content="Source code and graphics for the e-book, Create 3D Games."/>   
<meta property="og:image"   content="../../../../../assets/ssfb-7-all.jpg" />
    
<meta name="viewport" content="width=device-width, initial-scale=1">
<style>
@import url(../../../../../styles/7-base.css); 
@import url(../../../../../styles/7-wt.css);
hr{background-color: #160038; color: #160038; }   
</style>   
<link rel="stylesheet"  type="text/css" media="(max-width: 640px)" href="../../../../../styles/7-narrow.css"> 
<link rel="stylesheet"  type="text/css" media="(orientation: portrait)" href="../../../../../styles/7-portrait.css">
 
<script async src="../../../../../javascript/lib.js"></script>
<link rel="shortcut icon" href="../../../../../7.ico" />	
</head>
<body>
<?php include ('../../../../../php/7-t.php'); ?> 
<div class="content">
<h1>Create 3D Games: Downloads</h1>
<h2>Ebook Source Code and Graphics</h2>
<h3>Create 3D Games Downloads</h3>			
<ul>
<li><em>JavaScript, Web Pages with Shaders, and Graphics Zipped</em>: <a href="assets/3d-games.zip">3d-games.zip</a></li> 	 
<li><a href="#image" title="Graphics">Graphics</a></li>
<li><a href="#ht" title="Each Project with Default HTML Markup">Each Project with Default HTML Markup</a></li>
<li><a href="#js" title="Individual JavaScript Files">Individual JavaScript Files</a></li>
<li><a href="#models" title="Individual JavaScript Files">Model Files</a></li>
<li><a href="#styles" title="Individual JavaScript Files">Style Sheets</a></li>
</ul>

<h3>JavaScript Downloads</h3>
<ul>
<li>JavaScript: <a href="javascript/Controller.js">Generic Controller: Controller.js</a></li>  
<li>JavaScript: <a href="javascript/GlobeGame.js">Globe Game: GlobeGame.js</a></li> 
<li>JavaScript: <a href="javascript/BiplaneGame.js">Biplane Game: BiplaneGame.js</a></li> 
<li>JavaScript: <a href="javascript/IPhoneGame.js">iPhone Game: IPhoneGame.js</a></li>
</ul>

<h3 id="ht">Each Project with Default HTML Markup</h3>		
<ul>  
  <li>Web Page: <a href="globe-game.html">Globe Game: globe-game.html</a></li>   
  <li>Web Page: <a href="biplane-game.html">Biplane Game: biplane-game.html</a></li> 
  <li>Web Page: <a href="iphone-game.html">iPhone Game: iphone-game.html</a></li>     
</ul>

<h3>Project Maps and InfoGraphic Answer Sheets</h3>
<ul>
<li>Web Page: <a href="graphic-biplane-names.html">Biplane Graphic Answers</a></li>
<li>Web Page: <a href="graphic-biplane.html">Biplane Texture</a></li>
<li>Web Page: <a href="graphic-globe-names.html">Globe Graphic Answers</a></li>
<li>Web Page: <a href="graphic-globe.html">Globe Texture</a></li>
<li>Web Page: <a href="graphic-iphone-names.html">iPhone Graphic Answers</a></li>
<li>Web Page: <a href="graphic-iphone.html">iPhone Texture</a></li>
</ul>
 
<h3 id="js">Individual JavaScript Files</h3>
<ul>		
<li>JavaScript: <a href="javascript/Controller.js">Generic Controller: Controller.js</a></li>  
<li>JavaScript: <a href="javascript/Sprite.js">Sprite.js</a></li> 
<li>JavaScript: <a href="javascript/Responsive.js">Responsive.js</a></li>
<li>JavaScript: <a href="javascript/GameController.js">Game Controller: GameController.js</a></li>   
<li>JavaScript: <a href="javascript/GameConstants.js">GameConstants.js</a></li>	
<li>JavaScript: <a href="javascript/ColorEntity.js">Color Data: ColorEntity.js</a></li>    	
<li>JavaScript: <a href="javascript/glMatrix-0.9.5.min.js">Matrix Math: glMatrix-0.9.5.min.js</a></li> 
<li>JavaScript: <a href="javascript/GlobeGame.js">Globe Game: GlobeGame.js</a></li> 
<li>JavaScript: <a href="javascript/BiplaneGame.js">Biplane Game: BiplaneGame.js</a></li> 
<li>JavaScript: <a href="javascript/IPhoneGame.js">iPhone Game: IPhoneGame.js</a></li>
</ul>

<h3 id="models">Model Files</h3>
<ul> 
<li>JavaScript Model: <a href="javascript-models/Globe.js">Globe Model: Globe.js</a></li> 
<li>JavaScript Model: <a href="javascript-models/BiPlane.js">Biplane Model: BiPlane.js</a></li> 
<li>JavaScript Model: <a href="javascript-models/IPhone.js">iPhone Model: IPhone.js</a></li> 
</ul>

<h3 id="styles">Style Sheets</h3>
<p>
The style sheets, for all three games,
arrange elements based on screen orientation and width.
</p>
<ul> 
<li>Base Styles: <a href="styles/games.css">games.css</a></li> 
<li>Portrait and Narrow Styles: <a href="styles/portrait-narrow.css">portrait-narrow.css</a></li> 
</ul>

<h3>JavaScript Improvements</h3>
<p>
Small improvements were added to JavaScript source files, after publication.
The sooner source code tests for WebGL features,
the better. If WebGL's not available, then display
a message with a link to alternate content.
</p>
<p>
The <code>Controller, GlobeGame, BiplaneGame</code> and
<code>IPhoneGame</code> constructors test for
the existence of type <code>Float32Array</code>
<em>before</em> preparing WebGL content.
If <code>Float32Array</code> is <code>undefined</code>,
then the current Web browser doesn't support WebGL.
Therefore display an error message and a link to
content which doesn't require WebGL.
</p>
<p>
The following short listing demonstrates testing
for WebGL availability in the <code>GlobeGame</code>
constructor. The <code>GlobeGame</code>
constructor creates a new <code>Controller</code>
where the first argument equals zero.
The <code>Controller</code> will then call
method <code>viewGetWebGL()</code>. Readers
can modify <code>viewGetWebGL()</code>
to link to their own content.
</p>
<pre>
if (typeof Float32Array === 'undefined'){
 new Controller(0,null,null,null);
 return;
}
</pre>
<p>
Take a look at the following modified files, for details.
The changes are minimal, and toward the top of each JavaScript file, but allow non WebGL browsers
to exit gracefully.
</p>

<p>
 File <a href="assets/3d-games.zip">3d-games.zip</a>
 includes all texture maps, diagrams, shaders, HTML Web pages
 for each game, and all JavaScript.
</p>
<p>
 To run the projects on your local computer, please enable
 local file access.
 For example the following line starts the Chrome browser, with
 local file access.
</p>
<code>chrome.exe" --allow-file-access-from-files</code>

<h3 id="image">Graphics</h3>
<img class="ex" src="assets/globe.gif" alt="Globe Texture Map" />
<h3 class="ct">Globe Texture Map</h3>
<h4 class="ct">globe.gif</h4>
<hr />
<img class="ex" src="assets/graphic-globe-names.png" alt="Globe Answer Sheet" />
<h3 class="ct">Globe Answer Sheet</h3>
<h4 class="ct">graphic-globe-names.gif</h4>
<hr />
	
<img class="ex pt"  src="assets/biplane.gif" alt="Biplane Texture Map" />
<h3 class="ct">Biplane Texture Map</h3>
<h4 class="ct">biplane.gif</h4>
<hr />
<img class="ex pt"  src="assets/graphic-biplane-names.gif" alt="Biplane Answer Sheet" />
<h3 class="ct">Biplane Answer Sheet</h3>
<h4 class="ct">graphic-biplane-names.gif</h4>
<hr />
	
<img class="ex pt"  src="assets/iphone.gif" alt="iPhone Texture Map" />
<h3 class="ct">iPhone Texture Map</h3>
<h4 class="ct">iphone.gif</h4>
<hr />	
<img class="ex pt"  src="assets/graphic-iphone-names.gif" alt="iPhone Answer Sheet" />
<h3 class="ct">iPhone Answer Sheet</h3>
<h4 class="ct">graphic-iphone-names.gif</h4>	
	


<h3>Note</h3>
<p>
The book's style sheets with JavaScript, display models
at 100% width in landscape mode on small mobile devices. Feel free to modify
CSS rule-sets, color schemes, and JavaScript to fit the look and feel of your Website.
</p>
</div>
<?php include ('../../../../../php/7-f.php'); ?> 
</body>
</html> 