var GameController = function(sTexture,game){	

if (typeof Float32Array === 'undefined'){
 new Controller(0,null,null,null);
 return;
}

this.game = game;
 
this.nState = N_NOT_PLAYING;
this.nScore = Number(0);
this.nScoreHighest = Number(0);

this.aRight = null;
this.aTap = null;
this.aWrong = null;
this.aGameOver = null;
this.aCorrection = null;

this.eQuestion = null;
this.eInfo = null;
this.eScore = null;
this.eDebug = null;
 
this.nZoom = Number(1.0);
this.nZoomCumulate = Number(1.0);
this.bZoomLimit = false;

this.ceSelected = null;
 
this.bZoomLimit = false;

this.matrixModel = mat4.create();

mat4.set(
this.game.MATRIX_DEFAULT,
this.matrixModel
);

var aIm = new Array();

var model = game.model;

var entity =  new Sprite(sTexture,0);
entity.nOffset = Number(model.aOffset[0]);
entity.nCount = Number(model.aCount[0]);
aIm.push(entity);
 
this.getProperties();
this.getAudio();

var controller = new Controller
(
new Float32Array(model.aVertices),
new Uint16Array(model.aIndices),  
aIm,
this
); 

// Indicate this
// memory can be freed:
model.aVertices = null;
model.aIndices = null;
};

GameController.prototype = { 

init:function(controller){
 var gl = controller.gl;
 var glDemo = controller.glDemo;

 var matrix = controller.aSprites[0].matrix;

 mat4.set(glDemo.game.MATRIX_DEFAULT,matrix); 
   
 gl.enable
 (
  gl.DEPTH_TEST
 ); 
 
 this.aShuffleCurrent = this.game.aShuffles[0]; 
 glDemo.setListeners(
  controller
 );

 this.responsive = new Responsive(controller,glDemo.tapCanvas);
},

ceFind: function(controller,nX,nY){
var glDemo = controller.glDemo;
var aColorEntity = glDemo.game.aColorEntity;

glDemo.renderStationary(
controller
);

var gl = controller.gl;
var bFound = false;
var colors = new Uint8Array(4);

gl.readPixels(
nX,
nY, 
1,
1, 
gl.RGBA, 
gl.UNSIGNED_BYTE, 
colors
);	
 	
var nR = colors[0];
var nG = colors[1];
var nB = colors[2];

var ec = null;
 	
for (var i = 0; i < aColorEntity.length; i++){
 ec = aColorEntity[i];
 if(nR == ec.nR && nG == ec.nG && nB == ec.nB){
  bFound = true;
  glDemo.setScore(controller, ec);
  break;
 } 
} 

if (bFound == false){		
 glDemo.setScore(controller,null);
}

},
getAudio:function(){
 
this.aRight = document.getElementById
(
"aRight"
);
		 
this.aTap = document.getElementById
(
"aTap"
);
			
this.aGameOver = document.getElementById
(
"aGameOver"
);
		 
this.aCorrection = document.getElementById
(
"aCorrection"
);
 
this.aWrong = document.getElementById
(
"aWrong"
);

},

getProperties:function(){

this.eInfo = document.getElementById(
'eInfo'
);
	
this.eQuestion = document.getElementById(
'eQuestion'
);

this.eScore = document.getElementById(
'eScore'
);

this.eDebug = document.getElementById(
'eDebug'
);
},

getNextQuestion: function(controller){
	
var glDemo = controller.glDemo;
var aColorEntity = glDemo.game.aColorEntity;
var eQuestion = this.eQuestion;

if (glDemo.nQuestionCount >= glDemo.game.N_QUESTION_MAX )
{
glDemo.setGameOver(
controller
);	
return;
}	 

var aShuffleCurrent = this.aShuffleCurrent;
 
var nCount = this.nQuestionCount;	 
 
var nIdx = aShuffleCurrent[nCount];
 
nCount++; 

var ceSelected = glDemo.ceSelected = aColorEntity[nIdx];
eQuestion.innerHTML = nCount+". Find "+ceSelected.sName+".";
glDemo.eInfo.innerHTML = "Tap once to stop the "+glDemo.game.sType+".";
glDemo.nQuestionCount = nCount;
},

setShuffle:function(glDemo){
var aShuffles = glDemo.game.aShuffles;
var nShufflesLength = aShuffles.length;
var nShuffle = Number(0);
nShuffle = Math.floor(Math.random() * 10) % nShufflesLength;
 
if (nShuffle > nShufflesLength){
nShuffle = Number(0);
}
glDemo.aShuffleCurrent = aShuffles[nShuffle];
},

setListeners: function(controller){
 
var btnZoomIn = document.getElementById(
'btnZoomIn'
);
var btnZoomOut = document.getElementById(
'btnZoomOut'
);
 
btnZoomOut.controller = controller;
btnZoomIn.controller = controller;

btnZoomIn.addEventListener(
"click",
this.tapZoomIn,
false
);
 
btnZoomOut.addEventListener(
"click",
this.tapZoomOut,
false
);
  
var btnSpin = document.getElementById(
'btnSpin'
);
btnSpin.controller = controller;
btnSpin.addEventListener(
"click",
this.tapSpin,
false
);
 
var animStart = document.getElementById
(
"animStart"
);
 
animStart.controller = controller;
animStart.addEventListener
(
'click',
this.tapStart,
false
); 
},

tapStart:function(ev){		
var controller = ev.currentTarget.controller;
var glDemo = controller.glDemo; 
glDemo.nState = N_SPIN;
glDemo.reset(controller);

glDemo.setShuffle(glDemo);
 
glDemo.getNextQuestion(
controller
);
},

tapSpin: function(ev){
 var controller = ev.currentTarget.controller;
 var glDemo = controller.glDemo;
 var bSpin = false;
 var eInfo = glDemo.eInfo;

 switch(glDemo.nState){
 case N_SPIN:
 	eInfo.innerHTML = "Swipe to rotate the "+glDemo.game.sType+". You're already in spin mode.";
 	break;
 	
 case N_NOT_PLAYING:
 	eInfo.innerHTML = "Swipe to rotate the "+glDemo.game.sType+". You're already in spin mode.";
 	eInfo.innerHTML = S_HOW_TO_START;
 	break;
 	
 case N_SELECT_ITEM:
		glDemo.nState = N_SPIN;
  eInfo.innerHTML = "<em>Tap</em> the "+glDemo.game.sType+" to stop spinning. Find "+glDemo.ceSelected.sName+".";
 	break;
 	
 case N_GET_NEXT_QUESTION:
		glDemo.nState = N_SPIN;
 	glDemo.getNextQuestion(controller);
 	break;
 }
 
},

tapCanvas: function(nX,nY,controller){
	
var glDemo = controller.glDemo;

if(glDemo.N_NOT_PLAYING == true){
	
eInfo.innerHTML = S_HOW_TO_START;
return;

}
	
if (glDemo.nState == N_SPIN){
 glDemo.nState = N_SELECT_ITEM;
 glDemo.aTap.play();
 glDemo.eInfo.innerHTML = "Tap a <em>second time</em> to select "+glDemo.ceSelected.sName+". "+S_SPIN;		
 return;
}
		
if (glDemo.nState == N_SELECT_ITEM){

 glDemo.ceFind(controller,nX,nY);
 
 glDemo.nState = N_GET_NEXT_QUESTION;

}

else if(glDemo.nState == N_GET_NEXT_QUESTION){	
glDemo.nState = N_SPIN;
glDemo.getNextQuestion(controller);

}
},

tapZoomIn:function(ev){
	var controller = ev.currentTarget.controller;
	var glDemo = controller.glDemo;
	var nZoom = glDemo.nZoomCumulate * glDemo.nZoom;

	if (nZoom < glDemo.game.nMaxZoom){
	 if (nZoom < 1.0){
	  nZoom = 1.111;
	 }
	 else {
	 	nZoom += 0.111; 
	 }
	 glDemo.setZoom(controller,nZoom);
			
	 if (glDemo.bZoomLimit == true){
	 	controller.eDebug.innerHTML = "";
	 	glDemo.bZoomLimit = false;
	 }
	}
	else {
		controller.eDebug.innerHTML = "Maximum zoom displayed.";
		glDemo.bZoomLimit = true;
	}

},

tapZoomOut:function(ev){
	var controller = ev.currentTarget.controller;
	var glDemo = controller.glDemo;
	var nZoom = glDemo.nZoomCumulate * glDemo.nZoom;
	
	if(nZoom > 0.25){
	 if (nZoom > 1.0){
	  nZoom = 0.9;
	 }
	 else {
	 	nZoom -= 0.1; 	
	 }
	 
	 glDemo.setZoom(controller,nZoom);
	 
	 if (glDemo.bZoomLimit == true){
	 	controller.eDebug.innerHTML = "";
	 	glDemo.bZoomLimit = false;
	 }
	}
	else {
		controller.eDebug.innerHTML = "Minimum zoom displayed.";
		glDemo.bZoomLimit = true;
	}	
},

setZoom: function(controller,nZoom){
var sprite = controller.aSprites[0];
var glDemo = controller.glDemo;

glDemo.nZoom = nZoom;
glDemo.nZoomCumulate *= nZoom;
 
mat4.scale(
sprite.matrix,
[nZoom,nZoom,nZoom]
);

mat4.scale(
glDemo.matrixModel,
[nZoom,nZoom,nZoom]
);

glDemo.renderStationary(controller);
 
},

setGameOver: function(
	 controller
	){
var glDemo = controller.glDemo;

var eInfo = glDemo.eInfo;
var eDebug = glDemo.eDebug;
var eScore = glDemo.eScore;

eDebug.innerHTML = "";
glDemo.nState = N_NOT_PLAYING;
glDemo.aGameOver.play(); 
if (glDemo.nScore > 0){
	
if (glDemo.nScore > glDemo.nScoreHighest){
	
eScore.innerHTML = "Game Over! Your score "+glDemo.nScore;
eScore.innerHTML +=" was higher than your previous high score of "+glDemo.nScoreHighest+ ".";	 	 		
glDemo.nScoreHighest = this.nScore;

 if(glDemo.nScore == 100){
  eScore.innerHTML += "<br />Your score equals 100%!";
 }
 else {
  eScore.innerHTML +=" Your score equals "+glDemo.nScore+"%.";
 }
 
}
	 	 
else {
	
eScore.innerHTML = "Game Over! Your score was "+glDemo.nScore+". ";

}
	 	 
eInfo.innerHTML =	" Select the <em>Play</em> button to play again.";

}
	 
else {
	
glDemo.eQuestion.innerHTML = "";
eInfo.innerHTML = S_HOW_TO_START;

}
},

setRight:function(controller){	
this.aRight.play();
this.nScore += this.game.nIncrement;	
var ceSelected = this.ceSelected;		
this.eScore.innerHTML = "You found "+ceSelected.sName+"!";	
},

setWrong:function(controller){
this.aWrong.play();
this.eScore.innerHTML = "You didn't find "+this.ceSelected.sName+".";
},

setScore: function(controller,ce){
 if (ce == null || ce.idx != this.ceSelected.idx){
 	this.setWrong();
 }
 else {
 	this.setRight();
 }
 this.displayScore();	
},

displayScore:function(){	
 var nMax = this.nQuestionCount * this.game.nIncrement;
 var nPercent = Math.floor(Number(this.nScore/nMax) * 100);
 var eInfo = this.eInfo;
 var eScore = this.eScore;
 eScore.innerHTML +=" Your score equals "+nPercent+"% so far.";
 eScore.innerHTML +=" You have "+this.nScore+" points.";
 eInfo.innerHTML =" <em>Tap</em> the "+this.game.sType+" to see the next question.";
},

reset: function(controller){
this.nScore = 0;
this.nQuestionCount = 0;	
this.nState = N_SPIN;
this.eInfo.innerHTML = "Starting a new game!";
 
this.setShuffle(this);

if (this.ceSelected != null){
this.ceSelected.bSelected = false;
}
},

renderStationary: function(controller){
var gl = controller.gl;
var matrixModel = this.matrixModel;
var e = controller.aSprites[0];
	
gl.uniformMatrix4fv
(
controller.uMatrixTransform, 
false, 
new Float32Array
(
matrixModel
)
);
	
gl.drawElements
(
gl.TRIANGLES, 
e.nCount, 
gl.UNSIGNED_SHORT, 
e.nOffset
); 	
},

render: function(controller){
var glDemo = controller.glDemo;
var nState = glDemo.nState;

if (nState == N_SELECT_ITEM ||
 nState == N_GET_NEXT_QUESTION
 ){
 return;
}
if(nState == N_NOT_PLAYING){
glDemo.eInfo.innerHTML = S_HOW_TO_START;
}

var nMaxRotationX = glDemo.game.nMaxRotationX;
var sprite = controller.aSprites[0];
var matrix = sprite.matrix;
var gl = controller.gl;

var matrixModel = mat4.create(); 
mat4.set(matrix,matrixModel);
 
var pX = glDemo.nX;
var pY = glDemo.nY;
var nDiv = glDemo.nDiv;
var nMiddle = glDemo.nMiddle;
var nY = Number(0);
 
var rY = pX * nDiv;
var rX = Number(0);

if (pY > nMiddle){
nY = pY - nMiddle;
rX = nY * nDiv/4; 
}

else {
nY = nMiddle - pY;   
rX = -1 * nY * nDiv/4;
}
 
if(Math.abs(rX) > nMaxRotationX){
rY = nMaxRotationX - rX;
rX = rX - nMaxRotationX;    
}

mat4.rotate(
matrixModel, 
rX, 
[1, 0, 0]
);
 
mat4.rotate(
matrixModel,
rY,
glDemo.game.A_ROTATION_Y
);
 
gl.uniformMatrix4fv
(
controller.uMatrixTransform, 
false, 
new Float32Array
(
 matrixModel
)
); 
 
gl.drawElements
(
gl.TRIANGLES, 
sprite.nCount, 
gl.UNSIGNED_SHORT, 
sprite.nOffset
);  

glDemo.matrixModel = matrixModel;
},

};