var Responsive = function(
 controller,
 fClick
){
	
controller.responsive = this;

this.bb = null;

this.mXOffset = this.mYOffset = Number(0);

this.nGraphic = Number(0.40);

this.nText = Number(0.55);

this.fClick = fClick;

this.getElements();

this.setListeners(
 controller
);
 
this.listenerResize(
 controller
);

};

Responsive.prototype = {
		
getElements: function(){
	
this.eText = document.getElementById(
'eText'
);

this.eGraphic = document.getElementById(
'eGraphic'
);

this.eDebug = document.getElementById(
'eDebug'
);

},
		
setListeners: function(controller){
	
var cv = controller.cv; 

if (this.fClick != null){
 cv.addEventListener(
 'click',
 this.clickCanvas,
 false
 );
} 
 
if ("ontouchstart" in window){

cv.addEventListener
(
 'touchmove',    
 this.listenerMoveTouch,
 false   
);       
}
	
else {
cv.addEventListener
(
 'mousemove', 
 this.listenerMoveMouse, 
 false
);          
}  
	 
window.controller = controller;
	 
window.addEventListener
(
 'scroll',  
 this.listenerScroll 
);

window.addEventListener (
 'resize', 
 this.listenerResize  
);
  
},

listenerScroll: function(ev){

ev.preventDefault();
	    
var controller = ev.currentTarget.controller;

var responsive = controller.responsive;

responsive.setOffsets(
 controller
);

},

listenerResize: function(ev){
	
var controller = ev;

if (ev.currentTarget != null){
	
 ev.preventDefault(); 

 controller = ev.currentTarget.controller;
}

var glDemo = controller.glDemo;
var responsive = controller.responsive;

responsive.setElementDimensions(
 controller
);

glDemo.render(
 controller
);

},

setElementDimensions: function(
 controller
)
{ 

var responsive = controller.responsive;
 
var gl = controller.gl;

var nW = window.innerWidth * 0.9; 
 
var nH = window.innerHeight; 
 
var nCanvasDim = Number(0);
 
var nOutputDim = Number(0);

// Landscape orientation.
if (nW > nH){
   
// For narrow phones and mobile devices
// in landscape orientation.
if (nW < 640){
	
 nCanvasDim = Math.floor(nW * 0.9);
 nOutputDim = nCanvasDim;

}

else {
	
 nCanvasDim = Math.floor(nW * responsive.nGraphic);
 nOutputDim = Math.floor(nW * responsive.nText);

}
  
}

else {  
 nCanvasDim = Math.floor(nW * 0.9);
 
 nOutputDim = nCanvasDim;
 
}

responsive.setWidths(
 controller,
 nCanvasDim, 
 nOutputDim
);

responsive.setOffsets(
 controller
); 

gl.viewport(
 0, 
 0, 
 nCanvasDim, 
 nCanvasDim
);
},

setOffsets: function(controller){
	
 var nXScroll = Number(0);
 
 var nYScroll = Number(0);
 
 var responsive = controller.responsive;
 
 var cv = controller.cv;
 
 responsive.mXOffset = responsive.mYOffset = Number(0);
 
 var bb = cv.getBoundingClientRect();
 
 if (bb != null){    

  if (window.pageXOffset != null){
   nXScroll = window.pageXOffset;       
  }
  
  if (window.pageYOffset != null){
    nYScroll = window.pageYOffset;       
  }  

  if (bb.left > 0){
  	responsive.mXOffset = bb.left + nXScroll;
  }

  else if (nXScroll > 0){
  	responsive.mXOffset = nXScroll + bb.left;
  } 
  
  if (bb.top > 0){
  	responsive.mYOffset = bb.top + nYScroll;
  }
 
  else if (nYScroll > 0){
   	responsive.mYOffset = nYScroll + bb.top;
  } 
  
  responsive.bb = bb;

 }  
},

setWidths: function(
 controller,
 nCD,
 nDD
)
{   
var responsive = controller.responsive;

var glDemo = controller.glDemo;

var cv = controller.cv;

glDemo.nMiddle = nCD/2;

glDemo.nDiv = Math.PI*2/nCD;

if(glDemo.nX == null){
	glDemo.nX = glDemo.nMiddle;
}
if(glDemo.nY == null){
	glDemo.nY = glDemo.nMiddle;
}

var sCD = nCD.toString()+"px";

cv.width = nCD;

cv.height = nCD; 

cv.style.width = sCD;

cv.style.height = sCD;

responsive.eGraphic.style.width = sCD;

responsive.eText.style.width = nDD.toString()+"px"; 

},

listenerMoveTouch: function(ev){ 

ev.preventDefault();
 
var controller = ev.currentTarget.controller;
var responsive = controller.responsive;
var glDemo = controller.glDemo;
 
if (ev.targetTouches.length >=  1) {
 
var t1 = ev.targetTouches[0];  
  
glDemo.nX = t1.pageX - responsive.mXOffset; 
glDemo.nY = t1.pageY - responsive.mYOffset; 
  
glDemo.render(
 controller
);
  
}

},

listenerMoveMouse: function(ev){

ev.preventDefault();  

var controller = ev.currentTarget.controller;

var responsive = controller.responsive;

var glDemo = controller.glDemo;
 
glDemo.nX = ev.clientX - responsive.bb.left;

glDemo.nY = ev.clientY - responsive.bb.top;

glDemo.render(
 controller
);

},

clickCanvas: function(ev){
	
var controller = ev.currentTarget.controller;

var responsive = controller.responsive;

var bb = controller.cv.getBoundingClientRect();

var nX = Math.floor(ev.clientX - bb.left);

var nY = Math.floor(ev.clientY - bb.top);

responsive.fClick(
 nX,
 bb.height-nY,
 controller
);

},
};